@file:Suppress("UNCHECKED_CAST", "USELESS_CAST", "INAPPLICABLE_JVM_NAME", "UNUSED_ANONYMOUS_PARAMETER", "SENSELESS_COMPARISON", "NAME_SHADOWING", "UNNECESSARY_NOT_NULL_ASSERTION")
package uni.UNIHelloUniAppX
import io.dcloud.uniapp.*
import io.dcloud.uniapp.extapi.*
import io.dcloud.uniapp.framework.*
import io.dcloud.uniapp.runtime.*
import io.dcloud.uniapp.vue.*
import io.dcloud.uniapp.vue.shared.*
import io.dcloud.unicloud.*
import io.dcloud.uts.*
import io.dcloud.uts.Map
import io.dcloud.uts.Set
import io.dcloud.uts.UTSAndroid
import kotlin.properties.Delegates
import io.dcloud.uniapp.extapi.getElementById as uni_getElementById
open class GenPagesComponentGlobalEventsTouchEventsPreventDefaultClick : BasePage {
    constructor(__ins: ComponentInternalInstance, __renderer: String?) : super(__ins, __renderer) {
        onLoad(fun(_: OnLoadOptions) {
            stat_instance.onLoad(this)
        }
        , __ins)
        onPageShow(fun() {
            stat_instance.onShow(this)
        }
        , __ins)
        onPageHide(fun() {
            stat_instance.onHide(this)
        }
        , __ins)
        onUnload(fun() {
            stat_instance.onUnload(this)
        }
        , __ins)
    }
    open var data: DataType__37
        get() {
            return unref(this.`$exposed`["data"]) as DataType__37
        }
        set(value) {
            setRefValue(this.`$exposed`, "data", value)
        }
    companion object {
        @Suppress("UNUSED_PARAMETER", "UNUSED_VARIABLE")
        var setup: (__props: GenPagesComponentGlobalEventsTouchEventsPreventDefaultClick, __setupCtx: SetupContext) -> Any? = fun(__props, __setupCtx): Any? {
            val __expose = __setupCtx.expose
            val __ins = getCurrentInstance()!!
            val _ctx = __ins.proxy as GenPagesComponentGlobalEventsTouchEventsPreventDefaultClick
            val _cache = __ins.renderCache
            val data = reactive(DataType__37(isParentPreventDefault = false, isPreventDefault = false, isParentClickTrigger = false, isClickTrigger = false, eventDomRect = null as DOMRect?))
            __expose(_uM("data" to data))
            onReady(fun(){
                var element = uni_getElementById("eventClick")
                data.eventDomRect = element?.getBoundingClientRect()
            }
            )
            val onTouchEnd = fun(e: UniTouchEvent){
                if (data.isPreventDefault) {
                    console.log("执行了preventDefault，不再触发点击事件")
                    e.preventDefault()
                }
            }
            val onParentTouchEnd = fun(e: UniTouchEvent){
                if (data.isParentPreventDefault) {
                    console.log("执行了父的preventDefault，不再触发点击事件")
                    e.preventDefault()
                }
            }
            val onClick = fun(){
                console.log("触发了点击事件")
                data.isClickTrigger = true
            }
            val onParentClick = fun(){
                console.log("触发了父的点击事件")
                data.isParentClickTrigger = true
            }
            return fun(): Any? {
                return _cE("view", null, _uA(
                    _cE("view", _uM("onTouchend" to onParentTouchEnd, "onClick" to onParentClick, "style" to _nS(_uM("padding-bottom" to "100px", "background-color" to "darkgrey"))), _uA(
                        _cE("view", _uM("id" to "eventClick", "onTouchend" to onTouchEnd, "style" to _nS(_uM("width" to "100%", "height" to "300px", "background-color" to "yellow")), "onClick" to onClick), null, 36)
                    ), 36)
                ))
            }
        }
        val styles: Map<String, Map<String, Map<String, Any>>> by lazy {
            _nCS(_uA())
        }
        var inheritAttrs = true
        var inject: Map<String, Map<String, Any?>> = _uM()
        var emits: Map<String, Any?> = _uM()
        var props = _nP(_uM())
        var propsNeedCastKeys: UTSArray<String> = _uA()
        var components: Map<String, CreateVueComponent> = _uM()
    }
}
